/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2000-2003 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

#include "apr_arch_threadproc.h"

APR_DECLARE(apr_status_t) apr_proc_detach(int daemonize)
{
#ifndef OS9
    int x;

    chdir("/dd");

#ifdef HAVE_SETSID
    if (setsid() == -1) {
        return errno;
    }
#elif defined(NEXT) || defined(NEWSOS)
    if (setpgrp(0, getpid()) == -1) {
        return errno;
    }
#elif defined(OS2) || defined(TPF) || defined(MPE) || defined(OS9)
    /* do nothing */
#else
    if (setpgid(0, 0) == -1) {
        return errno;
    }
#endif

    /* close out the standard file descriptors */
    if (freopen("/nil", "r", stdin) == NULL) {
        return errno;
        /* continue anyhow -- note we can't close out descriptor 0 because we
         * have nothing to replace it with, and if we didn't have a descriptor
         * 0 the next file would be created with that value ... leading to
         * havoc.
         */
    }
    if (freopen("/nil", "w", stdout) == NULL) {
        return errno;
    }
     /* We are going to reopen this again in a little while to the error
      * log file, but better to do it twice and suffer a small performance
      * hit for consistancy than not reopen it here.
      */
    if (freopen("/nil", "w", stderr) == NULL) {
        return errno;
    }
#endif /* OS9 */
    return APR_SUCCESS;
}

#ifndef SUCCESS
#define SUCCESS 0
#endif

/* New waitpid provided by VCS-GmbH Christian Rattner */
pid_t waitpid(pid, pstatus, options)
pid_t pid;
int *pstatus, options;
{
		 error_code errcode, errcodewait;
		 status_code status = (status_code)-1;
		 process_id pidexit;
		 alarm_id alarmid;
		 signal_code sigcode = 0;

		 if (options != 0 && options != WNOHANG) {
		 		 errno = EINVAL;
		 		 return (pid_t)-1;
		 }
		 if ((options & WNOHANG) == WNOHANG && (errcode = _os_alarm_cycle(&alarmid, SIGWAKE, 2)) != SUCCESS) {
		 		 errno = errcode;
		 		 return (pid_t)-1;
		 }
		 pidexit = pid;
		 if (pid == -1)		 errcodewait = _os_wait(&pidexit, &status);
		 else		 		 		 errcodewait = _os_waitid(&pidexit, &status, &sigcode, 0);
		 if ((options & WNOHANG) == WNOHANG && (errcode = _os_alarm_delete(alarmid)) != SUCCESS) {
		 		 errno = errcode;
		 		 return (pid_t)-1;
		 }
		 if (pid == -1) {
		 		 if (errcodewait != SUCCESS) {
		 		 		 errno = errcodewait;
		 		 		 return (pid_t)-1;
		 		 }
		 		 if ((options & WNOHANG) == 0 && pidexit == 0) {
		 		 		 errno = EINTR;
		 		 		 return (pid_t)-1;
		 		 }
		 		 pid = pidexit;
		 } else {
		 		 if (errcodewait != SUCCESS) {
		 		 		 switch(errcodewait) {
		 		 		 		 case EOS_BSIG:
		 		 		 		 		 if ((options & WNOHANG) == WNOHANG && sigcode == 0) return 0;
		 		 		 		 		 else errno = EINTR;
		 		 		 		 		 break;
		 		 		 		 case EOS_IPRCID:
		 		 		 		 		 errno = ECHILD;
		 		 		 		 		 break;
		 		 		 		 default:
		 		 		 		 		 errno = errcodewait;
		 		 		 		 		 break;
		 		 		 }
		 		 		 return (pid_t)-1;
		 		 }
		 }
		 if (pstatus != NULL) *pstatus = status;
		 return pid;
}

